#ifndef _H_MXHW_CRYPTO_ENGINE
#define _H_MXHW_CRYPTO_ENGINE

#include "mxhw_crypto_driver.h"
/* memory offsets of registers */
#define _REG_RW_MXCIPHER_CTRL	0x0
#define _REG_RO_IOFIFO_INFO		0x8
#define _REG_RO_PARITY_INFO		0xC	
#define _REG_RW_MXCIPHER_KEY0	0x10
#define _REG_RW_MXCIPHER_IVIN0	0x30
#define _REG_RW_DMA_ADDR_SURC	0x48
#define _REG_RW_DMA_ADDR_DEST	0x4C
#define _REG_RW_DMA_DATA_SIZE	0x50
#define _REG_RW_DMA_ENGN_CTRL	0x54
#define _REG_RW_IOFIFO_THRD		0x58
#define _REG_RW_INTRPT_ENBL		0x5C
#define _REG_RO_INTRPT_PREV		0x60
#define _REG_RO_INTRPT_POST		0x64
#define _REG_WO_INTRPT_CLEAR	0x68
#define _REG_RO_REVISION_NUM	0x70
#define _REG_RO_IOFIFO_DEPTH	0x74
#define _REG_RO_MXCIPHER_IVOUT0	0x80

/* cipher control in bits */
#define _BIT_RW_MXCIPHER_PRTY_ENBL	0x0 //0x100
#define _BIT_RW_MXCIPHER_IVEC_ENBL	0x80

#define _BIT_RW_MXCIPHER_MODE_ECB		0x00
#define _BIT_RW_MXCIPHER_MODE_CBC		(0x10|_BIT_RW_MXCIPHER_IVEC_ENBL)
#define _BIT_RW_MXCIPHER_MODE_CTR		(0x20|_BIT_RW_MXCIPHER_IVEC_ENBL)
#define _BIT_RW_MXCIPHER_MODE_CFB		(0x40|_BIT_RW_MXCIPHER_IVEC_ENBL)
#define _BIT_RW_MXCIPHER_MODE_OFB		(0x50|_BIT_RW_MXCIPHER_IVEC_ENBL)
#define _BIT_RW_MXCIPHER_ALGO_DES		0x0
#define _BIT_RW_MXCIPHER_ALGO_3DES		0x2
#define _BIT_RW_MXCIPHER_ALGO_AES128	0x8
#define _BIT_RW_MXCIPHER_ALGO_AES192	0xa
#define _BIT_RW_MXCIPHER_ALGO_AES256	0xc
#define _BIT_RW_MXCIPHER_TYPE_ENC		0
#define _BIT_RW_MXCIPHER_TYPE_DEC		1

#define _BIT_RW_DMA_ENGN_ENBL		0x1
#define _BIT_RW_DMA_ENGN_DSBL		0x100
#define _BIT_RW_IFIFO_THREHOLD		0x1
#define _BIT_RW_OFIFO_THREHOLD		0x100

#define _BIT_RW_INTRPT_DONE			0x1
#define _BIT_RW_INTRPT_ERR			0x2
#define _BIT_RW_INTRPT_STOP			0x4
#define _BIT_RO_INTRPT_DONE			_BIT_RW_INTRPT_DONE
#define _BIT_RO_INTRPT_ERR			_BIT_RO_INTRPT_ERR
#define _BIT_RO_INTRPT_STOP			_BIT_RW_INTRPT_STOP

/* FIFO status in bits */
#define _RO_FIFO_IN_EMPTY			0x0
#define _RO_FIFO_IN_FULL			0x1
#define _RO_FIFO_OUT_EMPTY			0x2
#define _RO_FIFO_OUT_FULL			0x4
#define _RO_FIFO_NASK_COUN_IN		0xff0000
#define _RO_FIFO_NASK_COUN_OUT		0xff000000

#endif
